import re
from typing import List
C=[]
F=[]
K=[]

with open("js-globals.md") as fi:
    x=fi.read()
y=re.findall("\* ```(\w+?)```(.*?)(?=\n\*)",x,re.DOTALL|re.MULTILINE)
y=[(i,j.replace("\n","\n\n")) for i,j in y]
#y=[(i,j) for i,j in y if re.match("DROID|DORDER",i)]
C.extend(y)

with open("js-objects.md") as fi:
    x=fi.read()
y=re.findall("```(\w+?)```(.*?)(?=`|\n+$)",x,re.DOTALL|re.MULTILINE)
y=[(i,j.replace("\n","\n\n")) for i,j in y]
#y=[(i,j) for i,j in y if re.match("DROID|DORDER",i)]
C.extend(y)



def sub2(y:List[str]):
    y=[(re.sub("<|>|\[|\]","",i),j) for i,j in y] 
    y=[(re.sub("\|","=",i),j) for i,j in y] 
    y=[(re.sub("(\w+?)\.\.\.",lambda i:"..."+i.group(1),i),j) for i,j in y] 
    return y

with open("js-functions.md") as fi:
    x=fi.read()
y=re.findall("## (.*?)\n\n(.*?)(?=#|\n+$)",x,re.DOTALL|re.MULTILINE)
y=sub2(y)
F.extend(y)

with open("js-events.md") as fi:
    x=fi.read()
y=re.findall("## (.*?)\n\n(.*?)(?=#|\n+$)",x,re.DOTALL|re.MULTILINE)
y=sub2(y)
F.extend(y)



C.sort()
F.sort()


d=[]
with open("pylint.js","w") as fi:
    with open("object0.js") as fi2:
        fi.write(fi2.read())
    for i,j in C:
        i:str
        j:str  
        if i in d:
            continue
        d.append(i)
        print(f"/**{j.strip()}*/",file=fi)
        print(f"const {i}='{i}'",file=fi)
        print(f"",file=fi)    

    for i,j in F:
        i:str
        j:str
        if i in d:
            continue
        print(i)
        d.append(i)
        ret=""
        if i.startswith("enum") or i.startswith("get"):
            h="object"
            if i.startswith("get"):h=""
            for w in ["Research","Droid","Struct","Object"]: 
                if w in i:
                    h=w.lower()
                    break
            h=h+"0"
            if i.startswith("enum"):
                h="[%s]"%h
            ret="return %s"%h
        print(f"/**{j.strip()}*/",file=fi)
        print(f"function {i} "+"{%s}"%ret,file=fi)
        

        print(f"",file=fi)         
